#include "includes.h"
#include "workwithfiles.h"

BOOL LoadItems(TCHAR *FName)
{
	HANDLE hFile=FileCreate(FName,OPEN_EXISTING);
	if (!hFile)
	{
		MessageBox(HANDLES.hWndMain,"   ","",MB_OK);
		return FALSE;
	}

	int dwWkCount1=GetRecCount(hFile);
	
	if (dwWkCount1<=0)
	{
		MessageBox(HANDLES.hWndMain,"   ","",MB_OK);
		return FALSE;
	}
	dwWkCount=dwWkCount1;
	Record Rec;	
	delete [] WkRec;
	WkRec=new WorkRecord[dwWkCount];
	for (int i=0;i<dwWkCount;i++)
	{
		FileRead(hFile,Rec);
		Rec2Work(&WkRec[i],Rec);
	}
	CloseFiles(hFile);
	return TRUE;
}

BOOL SaveItems(TCHAR *FName)
{
	HANDLE hFile=FileCreate(FName,CREATE_ALWAYS);
	if (!hFile)
	{
		MessageBox(HANDLES.hWndMain,"     ","",MB_OK);
		return FALSE;
	}
	Record Rec;	
	for (int i=0;i<dwWkCount;i++)
	{
		ZeroMemory(&Rec,sizeof(Record));
		Work2Rec(&Rec,WkRec[i]);
		if (!FileWrite(hFile,Rec))
			return FALSE;
	}
	CloseFiles(hFile);
	return TRUE;
}


void Rec2Work(WorkRecord *WkRec,Record rec)
{
	strcpy(WkRec->cSinger,rec.cSinger);
	strcpy(WkRec->cDisc,rec.cDisc);
	strcpy(WkRec->cTrack,rec.cTrack);
	strcpy(WkRec->cDate,rec.cDate);
	strcpy(WkRec->cGroup,rec.cGroup);
	strcpy(WkRec->cPlace,rec.cPlace);
	WkRec->ind=rec.ind;
	WkRec->indParent=rec.indParent;
	WkRec->iNum=rec.iNum;
	WkRec->iType=rec.iType;
	WkRec->hTree=NULL;
}

void Work2Rec(Record *Rec,WorkRecord wkRec)
{
	strcpy(Rec->cSinger,wkRec.cSinger);
	strcpy(Rec->cDisc,wkRec.cDisc);
	strcpy(Rec->cTrack,wkRec.cTrack);
	strcpy(Rec->cDate,wkRec.cDate);
	strcpy(Rec->cGroup,wkRec.cGroup);
	strcpy(Rec->cPlace,wkRec.cPlace);
	Rec->ind=wkRec.ind;
	Rec->indParent=wkRec.indParent;
	Rec->iNum=wkRec.iNum;
	Rec->iType=wkRec.iType;
}

BOOL GetFlNameDialog( HWND hWnd,int i )
{
    lstrcpy(FileName, "");
    OPENFILENAME ofn;
	ZeroMemory(&ofn,sizeof(OPENFILENAME ));
	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner         = hWnd;
	if (i==0)
		ofn.lpstrTitle    = " ";
	else if (i==1)			  
		ofn.lpstrTitle    = "";
	else
		ofn.lpstrTitle    = " ";
	ofn.lpstrFilter       = " (*.ddb)\0*.ddb";
	ofn.nFilterIndex      = 1;
	ofn.lpstrFile         = FileName;
	ofn.nMaxFile          = 1000;
	ofn.lpstrInitialDir   = NULL;
	ofn.Flags =   OFN_PATHMUSTEXIST  | OFN_HIDEREADONLY;
	return GetOpenFileName(&ofn);
}	


BOOL CloseFile(HANDLE hFile)
{	
	return CloseHandle(hFile);
}

DWORD GetRecCount(HANDLE hFile)
{
	DWORD dwSize;
	dwSize=GetFileSize(hFile,NULL);
	dwSize/=sizeof(Record);
	return dwSize;
}

HANDLE FileCreate(TCHAR *name, DWORD CreatDispos)
{
	return CreateFile(name,GENERIC_READ|GENERIC_WRITE, 0, NULL, CreatDispos,
		FILE_ATTRIBUTE_NORMAL, NULL);
}

BOOL FileRead(HANDLE hFile,Record &Rec)
{
	DWORD dwCountRead;
	return ReadFile(hFile,&Rec,sizeof(Record),&dwCountRead,NULL);
}

BOOL FileWrite(HANDLE hFile,Record Rec)
{
	DWORD dwNumOfBytesWritten;
	return WriteFile(hFile,&Rec,sizeof(Record),&dwNumOfBytesWritten,NULL);
}

BOOL CloseFiles(HANDLE hFile)
{
	return CloseHandle(hFile);
}